#!/usr/bin/perl -w
use warnings;
use strict;
use CGI qw/:standard/;
use SOAP::Lite;
use XML::Simple;

use LWP::UserAgent;
use HTTP::Request;
use HTTP::Headers;



use constant GATEWAY => "https://gateway.agms.com/roxapi/agms.asmx";
 
my $q = new CGI;


 
print $q->header("text/html"),$q->start_html(
                                             -title => 'AGMS Gateway - Perl Example',                                                  
                                             -style => { 
                                                        -src => 'styles.css' 
                                                       }
                                             );

print $q->start_form(
                       -name => 'main',
                       -method => 'POST',
                    );

											 
if($q->param())
{
	my $TransactionType = $q->param('TransactionType');
	my $GatewayUserName = $q->param('GatewayUserName');
	my $GatewayPassword = $q->param('GatewayPassword');
	my $PaymentType = $q->param('PaymentType');
	my $TransactionID = $q->param('TransactionID');
	my $Amount = $q->param('Amount');	
	my $Tax = $q->param('Tax');
	my $Shipping = $q->param('Shipping');
	my $OrderDescription = $q->param('OrderDescription');
	my $OrderID = $q->param('OrderID');
	my $PONumber = $q->param('PONumber');
	my $CCNumber = $q->param('CCNumber');
	my $CCExpDate = $q->param('CCExpDate');
    my $CVV = $q->param('CVV');
    my $CheckName = $q->param('CheckName');
	my $CheckABA = $q->param('CheckABA');
	my $CheckAccount = $q->param('CheckAccount');
	my $AccountHolderType = $q->param('AccountHolderType');
	my $AccountType = $q->param('AccountType');
	my $SecCode = $q->param('SecCode');
	my $FirstName = $q->param('FirstName');
	my $LastName = $q->param('LastName');
	my $Company = $q->param('Company');
	my $Address1 = $q->param('Address1');
	my $Address2 = $q->param('Address2');
	my $City = $q->param('City');
	my $State = $q->param('State');
	my $Zip = $q->param('Zip');
	my $Country = $q->param('Country');
	my $Phone = $q->param('Phone');
	my $Fax = $q->param('Fax');
	my $Email = $q->param('Email');
	my $Website = $q->param('Website');
	my $ShippingFirstName = $q->param('ShippingFirstName');
	my $ShippingLastName = $q->param('ShippingLastName');
	my $ShippingCompany = $q->param('ShippingCompany');
	my $ShippingAddress1 = $q->param('ShippingAddress1');
	my $ShippingAddress2 = $q->param('ShippingAddress2');
	my $ShippingCity = $q->param('ShippingCity');
	my $ShippingState = $q->param('ShippingState');
	my $ShippingZip = $q->param('ShippingZip');
	my $ShippingCountry = $q->param('ShippingCountry');
	my $ShippingEMail = $q->param('ShippingEMail');	
	my $Tracking_Number = $q->param('Tracking_Number');
	my $Shipping_Carrier = $q->param('Shipping_Carrier');
	my $ProcessorID = $q->param('ProcessorID');
	my $IPAddress;
	my $Track1;
	my $Track2;
	my $Track3;
	my $Custom_Field_1 = $q->param('Custom_Field_1');
	my $Custom_Field_2 = $q->param('Custom_Field_2');
	my $SAFE_Action = $q->param('SAFE_Action');
	my $SAFE_ID = $q->param('SAFE_ID');

	my $soap_xml;

$soap_xml = "<soap:Envelope
   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"
   xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\"
   xmlns:soap=\"http://www.w3.org/2003/05/soap-envelope\">
   <soap:Body>
     <ProcessTransaction xmlns=\"https://gateway.agms.com/roxapi/\">
        <objparameters>\n";
        
if ($TransactionType) { $soap_xml .= "\t   <TransactionType>$TransactionType</TransactionType>\n"};
if ($GatewayUserName) { $soap_xml .= "\t   <GatewayUserName>$GatewayUserName</GatewayUserName>\n"};
if ($GatewayPassword) { $soap_xml .= "\t   <GatewayPassword>$GatewayPassword</GatewayPassword>\n"};
if ($PaymentType) { $soap_xml .= "\t   <PaymentType>$PaymentType</PaymentType>\n"};
if ($Amount) { $soap_xml .= "\t   <Amount>$Amount</Amount>\n"};
if ($Tax) { $soap_xml .= "\t   <Tax>$Tax</Tax>\n"};
if ($Shipping) { $soap_xml .= "\t   <Shipping>$Shipping</Shipping>"};
if ($OrderDescription) { $soap_xml .= "\t   <OrderDescription>$OrderDescription</OrderDescription>\n"};
if ($OrderID) { $soap_xml .= "\t   <OrderID>$OrderID</OrderID>\n"};
if ($PONumber) { $soap_xml .= "\t   <PONumber>$PONumber</PONumber>\n"};
if ($CCNumber) { $soap_xml .= "\t   <CCNumber>$CCNumber</CCNumber>\n"};
if ($CCExpDate) { $soap_xml .= "\t   <CCExpDate>$CCExpDate</CCExpDate>\n"};
if ($CVV) { $soap_xml .= "\t   <CVV>$CVV</CVV>\n"};
if ($CheckName) { $soap_xml .= "\t   <CheckName>$CheckName</CheckName>\n"};
if ($CheckABA) { $soap_xml .= "\t   <CheckABA>$CheckABA</CheckABA>\n"};
if ($CheckAccount) { $soap_xml .= "\t   <CheckAccount>$CheckAccount</CheckAccount>\n"};
if ($AccountHolderType) { $soap_xml .= "\t   <AccountHolderType>$AccountHolderType</AccountHolderType>\n"};
if ($AccountType) { $soap_xml .= "\t   <AccountType>$AccountType</AccountType>\n"};
if ($SecCode) { $soap_xml .= "\t   <SecCode>$SecCode</SecCode>\n"};
if ($FirstName) { $soap_xml .= "\t   <FirstName>$FirstName</FirstName>\n"};
if ($LastName) { $soap_xml .= "\t   <LastName>$LastName</LastName>\n"};
if ($Company) { $soap_xml .= "\t   <Company>$Company</Company>\n"};
if ($Address1) { $soap_xml .= "\t   <Address1>$Address1</Address1>\n"};
if ($Address2) { $soap_xml .= "\t   <Address2>$Address2</Address2>\n"};
if ($City) { $soap_xml .= "\t   <City>$City</City>\n"};
if ($State) { $soap_xml .= "\t   <State>$State</State>\n"};
if ($Zip) { $soap_xml .= "\t   <Zip>$Zip</Zip>\n"};
if ($Country) { $soap_xml .= "\t   <Country>$Country</Country>\n"};
if ($Phone) { $soap_xml .= "\t   <Phone>$Phone</Phone>\n"};
if ($Fax) { $soap_xml .= "\t   <Fax>$Fax</Fax>\n"};
if ($Email) { $soap_xml .= "\t   <Email>$Email</Email>\n"};
if ($Website) { $soap_xml .= "\t   <Website>$Website</Website>\n"};
if ($ShippingFirstName) { $soap_xml .= "\t   <ShippingFirstName>$ShippingFirstName</ShippingFirstName>\n"};
if ($ShippingLastName) { $soap_xml .= "\t   <ShippingLastName>$ShippingLastName</ShippingLastName>\n"};
if ($ShippingCompany) { $soap_xml .= "\t   <ShippingCompany>$ShippingCompany</ShippingCompany>\n"};
if ($ShippingAddress1) { $soap_xml .= "\t   <ShippingAddress1>$ShippingAddress1</ShippingAddress1>\n"};
if ($ShippingAddress2) { $soap_xml .= "\t   <ShippingAddress2>$ShippingAddress2</ShippingAddress2>\n"};
if ($ShippingCity) { $soap_xml .= "\t   <ShippingCity>$ShippingCity</ShippingCity>\n"};
if ($ShippingState) { $soap_xml .= "\t   <ShippingState>$ShippingState</ShippingState>\n"};
if ($ShippingZip) { $soap_xml .= "\t   <ShippingZip>$ShippingZip</ShippingZip>\n"};
if ($ShippingCountry) { $soap_xml .= "\t   <ShippingCountry>$ShippingCountry</ShippingCountry>\n"};
if ($ShippingEMail) { $soap_xml .= "\t   <ShippingEMail>$ShippingEMail</ShippingEMail>\n"};
if ($ProcessorID) { $soap_xml .= "\t   <ProcessorID>$ProcessorID</ProcessorID>\n"};
if ($TransactionID) { $soap_xml .= "\t   <TransactionID>$TransactionID</TransactionID>\n"};
if ($Tracking_Number) { $soap_xml .= "\t   <Tracking_Number>$Tracking_Number</Tracking_Number>\n"};
if ($Shipping_Carrier) { $soap_xml .= "\t   <Shipping_Carrier>$Shipping_Carrier</Shipping_Carrier>\n"};
if ($IPAddress) { $soap_xml .= "\t   <IPAddress>$IPAddress</IPAddress>\n"};
if ($Track1) { $soap_xml .= "\t   <Track1>$Track1</Track1>\n"};
if ($Track2) { $soap_xml .= "\t   <Track2>$Track2</Track2>\n"};
if ($Track3) { $soap_xml .= "\t   <Track3>$Track3</Track3>\n"};
if ($Custom_Field_1) { $soap_xml .= "\t   <Custom_Field_1>$Custom_Field_1</Custom_Field_1>\n"};
if ($Custom_Field_2) { $soap_xml .= "\t   <Custom_Field_2>$Custom_Field_2</Custom_Field_2>\n"};
if ($SAFE_Action) { $soap_xml .= "\t   <SAFE_Action>$SAFE_Action</SAFE_Action>\n"};
if ($SAFE_ID) { $soap_xml .= "\t   <SAFE_ID>$SAFE_ID</SAFE_ID>\n"};

$soap_xml .= "         </objparameters>
       </ProcessTransaction>
    </soap:Body>
 </soap:Envelope>";

my $request;
my $header = HTTP::Headers->new;
my $user_agent;
my $response;

$header->push_header('Content-Type' => 'text/xml');
$request = HTTP::Request->new("POST", GATEWAY, $header, $soap_xml);
$user_agent = LWP::UserAgent->new;
$response = $user_agent->request($request);


	if (!$response->is_error) 
	{
	   $response = XMLin($response->content, SuppressEmpty => 1 )->{'soap:Body'}->{'ProcessTransactionResponse'}->{'ProcessTransactionResult'};
	   
	   print "<br /><br /><br /><br /><br />";
	   
	   if($response->{'STATUS_CODE'}) {print "STATUS_CODE: $response->{'STATUS_CODE'}<br />";}
	   else{print "STATUS_CODE:<br />";}
	   
	   if($response->{'STATUS_MSG'}) {print "STATUS_MSG: $response->{'STATUS_MSG'}<br />";}
	   else{print "STATUS_MSG:<br />";}
	   
	   if($response->{'TRANS_ID'}) {print "TRANS_ID: $response->{'TRANS_ID'}<br />";}
	   else{print "TRANS_ID:<br />";}
	   
	   if($response->{'AUTH_CODE'}) {print "AUTH_CODE: $response->{'AUTH_CODE'}<br />";}
	   else{print "AUTH_CODE:<br />";}
	   
	   if($response->{'AVS_MSG'}) {print "AVS_MSG: $response->{'AVS_MSG'}<br />";}
	   else{print "AVS_MSG:<br />";}
	   
	   if($response->{'CVV2_CODE'}) {print "CVV2_CODE: $response->{'CVV2_CODE'}<br />";}
	   else{print "CVV2_CODE:<br />";}
	   
	   if($response->{'CVV2_MSG'}) {print "CVV2_MSG: $response->{'CVV2_MSG'}<br />";}
	   else{print "CVV2_MSG:<br />";}
	   
	   if($response->{'ORDERID'}) {print "ORDERID: $response->{'ORDERID'}<br />";}
	   else{print "ORDERID:<br />";}
	   
	   if($response->{'SAFE_ID'}) {print "SAFE_ID: $response->{'SAFE_ID'}<br />";}
	   else{print "SAFE_ID:<br />";}
	   
	   # if($response->{'FULLRESPONSE'}) {print "FULLRESPONSE: $response->{'FULLRESPONSE'}<br />";}
	   # else{print "FULLRESPONSE:<br />";}
	   # 
	   # if($response->{'POSTSTRING'}) {print "POSTSTRING: $response->{'POSTSTRING'}<br />";}
	   # else{print "POSTSTRING:<br />";}
	   
	}
	else 
	{
	   print("An error occurred while calling web service.\n");
	}
	
}	

print $q->start_table({-border=> 0, -cellspacing=> 0, -cellpadding=> 0, -class=>'main_box'});


             			 
print $q->Tr($q->td({-class=>'mb_left', -style=>'width: 20px'}), 
             $q->td({-class=>'mb_header'}, $q->h1('AGMS Gateway - Perl Example')), 
             $q->td({-class=>'mb_right', -style=>'width: 20px'}));
             
print $q->Tr($q->td({-class=>'mb_left', -style=>'width: 20px'}), 
             $q->td({-class=>'mb_main'}, $q->p(''),
             
                   $q->start_table({-name=>'table1',-align=>'center', -cellspacing=> 0, -cellpadding=> 0, -class=>'portalhtml'}),
                   
                   $q->Tr($q->th({-colspan=> 4},'Gateway API Demonstration')),
				   
                   $q->Tr($q->td({-style=>'width: 115px'},'TransactionType'),
                          $q->td({-width=> 225},$q->popup_menu(-name =>'TransactionType', -class=>'inputd', -values=>['sale','auth','capture','refund','void','update'], -defaults=>['sale'])),
                          $q->td({-colspan=> 2},'')),
                   
                   $q->Tr($q->td('GatewayUserName'),
                          $q->td($q->textfield(-name =>'GatewayUserName', -class=>'inputd', -values=>'your username')),
                          $q->td({-width=> 225}, 'GatewayPassword'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'GatewayPassword', -class=>'inputd', -values=>'your password'))),
                          
                   $q->Tr($q->td({-width=> 225}, 'PaymentType'),
                          $q->td({-width=> 225}, $q->popup_menu(-name =>'PaymentType', -class=>'inputd', -values=>['creditcard','check'])),      
                          $q->td({-width=> 225}, 'TransactionID'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'TransactionID', -class=>'inputd'))),                         
                          
                   $q->Tr($q->td({-colspan=> 4}, '<br />')),       
                          
                   $q->Tr($q->th({-colspan=> 4},'Credit Card Info')),      
                          
                   $q->Tr($q->td('CCNumber'),
                          $q->td($q->textfield(-name =>'CCNumber', -class=>'inputd', -values=>'')),
                          $q->td({-width=> 225}, 'CCExpDate (MMDD)'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'CCExpDate', -class=>'inputd', -values=>''))),     
                          
				   $q->Tr($q->td('CVV'),
                          $q->td($q->textfield(-style=>'width:50px', -name =>'CVV', -class=>'inputd', -values=>'')),
                          $q->td({-colspan=> 2})),      
                          
                   $q->Tr($q->td({-colspan=> 4}, '<br />')),       
                          
                   $q->Tr($q->th({-colspan=> 4},'Check (ACH) Info')),          
                          
                   $q->Tr($q->td('CheckName'),
                          $q->td({-colspan=> 3}, $q->textfield(-style=>'width:350px', -name=>'CheckName', -class=>'inputd'))),       
                          
                   $q->Tr($q->td('CheckABA'),
                          $q->td($q->textfield(-name =>'CheckABA', -class=>'inputd')),
                          $q->td({-width=> 225}, 'CheckAccount'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'CheckAccount', -class=>'inputd'))),      
                          
                   $q->Tr($q->td('AccountHolderType'),
                          $q->td({-width=> 225}, $q->popup_menu(-name =>'AccountHolderType', -class=>'inputd', -values=>['','business','personal'])),      
                          $q->td({-width=> 225}, 'AccountType'),
                          $q->td({-width=> 225}, $q->popup_menu(-name =>'AccountType', -class=>'inputd', -values=>['','checking','savings']))),   
                   
				   $q->Tr($q->td('SecCode'),
                          $q->td($q->popup_menu(-name =>'SecCode', -class=>'inputd', -values=>['','PPD','WEB','TEL','CCD'])),
                          $q->td({-colspan=> 2})),      
                          
                   $q->Tr($q->td({-colspan=> 4}, '<br />')),       
                          
                   $q->Tr($q->th({-colspan=> 4},'Transaction Information')),          
                          
				   $q->Tr($q->td('Amount'),
                          $q->td($q->textfield(-name =>'Amount', -class=>'inputd', -values=>'')),
                          $q->td({-colspan=> 2})), 	  
						  
				   $q->Tr($q->td('OrderDescription'),
                           $q->td({-colspan=> 3}, $q->textfield(-style=>'width:350px', -name=>'OrderDescription', -class=>'inputd'))),	  
						  
				   $q->Tr($q->td('Tax'),
                          $q->td($q->textfield(-name =>'Tax', -class=>'inputd')),
                          $q->td({-width=> 225}, 'Shipping'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'Shipping', -class=>'inputd'))), 
						  
				   $q->Tr($q->td('OrderID'),
                          $q->td($q->textfield(-name =>'OrderID', -class=>'inputd')),
                          $q->td({-width=> 225}, 'PONumber'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'PONumber', -class=>'inputd'))), 						  
						  
				   $q->Tr($q->td({-colspan=> 4}, '<br />')),       
                          
				   $q->Tr($q->th({-colspan=> 4},'Billing Information')),	  
						  
				   $q->Tr($q->td('FirstName'),
                          $q->td($q->textfield(-name =>'FirstName', -class=>'inputd')),
                          $q->td({-width=> 225}, 'LastName'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'LastName', -class=>'inputd'))),		  
						  
				   $q->Tr($q->td('Company'),
                          $q->td({-colspan=> 3}, $q->textfield(-style=>'width:350px', -name=>'Company', -class=>'inputd'))), 
						  
				   $q->Tr($q->td('Address1'),
                          $q->td({-colspan=> 3}, $q->textfield(-style=>'width:350px', -name=>'Address1', -class=>'inputd'))),
						  
				   $q->Tr($q->td('Address2'),
                          $q->td({-colspan=> 3}, $q->textfield(-style=>'width:350px', -name=>'Address2', -class=>'inputd'))), 						  
						  
			 	   $q->Tr($q->td('City'),
                          $q->td($q->textfield(-name =>'City', -class=>'inputd')),
                          $q->td({-width=> 225}, 'State'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'State', -class=>'inputd'))),	

				   $q->Tr($q->td('Zip'),
                          $q->td($q->textfield(-name =>'Zip', -class=>'inputd')),
                          $q->td({-width=> 225}, 'Country'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'Country', -class=>'inputd'))),	

				   $q->Tr($q->td('Phone'),
                          $q->td($q->textfield(-name =>'Phone', -class=>'inputd')),
                          $q->td({-width=> 225}, 'Fax'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'Fax', -class=>'inputd'))),	

				   $q->Tr($q->td('EMail'),
                          $q->td($q->textfield(-name =>'EMail', -class=>'inputd')),
                          $q->td({-width=> 225}, 'Website'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'Website', -class=>'inputd'))),							  
						  
				   $q->Tr($q->td({-colspan=> 4}, '<br />')),       
                          
                   $q->Tr($q->th({-colspan=> 4},'Shipping Information')),		  
                          
                   $q->Tr($q->td('FirstName'),
                          $q->td($q->textfield(-name =>'ShippingFirstName', -class=>'inputd')),
                          $q->td({-width=> 225}, 'LastName'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'ShippingLastName', -class=>'inputd'))),		  
						  
				   $q->Tr($q->td('Company'),
                          $q->td({-colspan=> 3}, $q->textfield(-style=>'width:350px', -name=>'ShippingCompany', -class=>'inputd'))), 
						  
                   $q->Tr($q->td('Address1'),
                          $q->td({-colspan=> 3}, $q->textfield(-style=>'width:350px', -name=>'ShippingAddress1', -class=>'inputd'))),
						  
                   $q->Tr($q->td('Address2'),
                          $q->td({-colspan=> 3}, $q->textfield(-style=>'width:350px', -name=>'ShippingAddress2', -class=>'inputd'))), 						  
						  
				   $q->Tr($q->td('City'),
                          $q->td($q->textfield(-name =>'ShippingCity', -class=>'inputd')),
                          $q->td({-width=> 225}, 'State'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'ShippingState', -class=>'inputd'))),	

				   $q->Tr($q->td('Zip'),
                          $q->td($q->textfield(-name =>'ShippingZip', -class=>'inputd')),
                          $q->td({-width=> 225}, 'Country'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'ShippingCountry', -class=>'inputd'))), 

				   $q->Tr($q->td('Email'),
                          $q->td($q->textfield(-name =>'ShippingEmail', -class=>'inputd')),
                          $q->td({-colspan=> 2})),

				   $q->Tr($q->td('Tracking Number'),
                          $q->td($q->textfield(-name =>'Tracking_Number', -class=>'inputd')),
                          $q->td({-width=> 225}, 'Shipping Carrier'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'Shipping_Carrier', -class=>'inputd'))), 

				   $q->Tr($q->th({-colspan=> 4},'Optional Features')),	

				   $q->Tr($q->td('ProcessorID'),
                          $q->td($q->textfield(-name =>'ProcessorID', -class=>'inputd')),
                          $q->td({-colspan=> 2})),

				   $q->Tr($q->td('Custom Field 1'),
                          $q->td($q->textfield(-name =>'Custom_Field_1', -class=>'inputd')),
                          $q->td({-width=> 225}, 'Custom Field 2'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'Custom_Field_2', -class=>'inputd'))),
                   
				   $q->Tr($q->td({-width=> 225}, 'SAFE Action'),
                          $q->td({-width=> 225}, $q->popup_menu(-name =>'SAFE_Action', -class=>'inputd', -values=>['','add_customer','update_customer','delete_customer'])),      
                          $q->td({-width=> 225}, 'SAFE ID'),
                          $q->td({-width=> 225}, $q->textfield(-name =>'SAFE_ID', -class=>'inputd'))), 
                       

                   $q->end_table,
				 
				   $q->start_table({-align=>'center', -cellspacing=> 0, -cellpadding=> 0}),
                   
				   $q->p('<br />'),
				   
				   $q->Tr($q->td($q->submit(-name => 'submit', -value => 'Continue'))), 
				   
				   $q->end_table),
				   
             $q->td({-class=>'mb_right', -style=>'width: 20px'}));         

print $q->Tr($q->td({-class=>'mb_bottomleft', -style=>'width: 20px'}), 
             $q->td({-class=>'mb_bottom'}), 
             $q->td({-class=>'mb_bottomright', -style=>'width: 20px'}));

print $q->end_table;

print $q->start_table({-border=> 0, -cellspacing=> 0, -cellpadding=> 0, -class=>'main_box', -style=>'width:565px'});

print $q->Tr($q->td({-class=>'mb_topleft', -style=>'width: 20px'}), 
             $q->td({-class=>'mb_top'}), 
             $q->td({-class=>'mb_topright', -style=>'width: 20px'}));
			 
print $q->Tr($q->td({-class=>'mb_left', -style=>'width: 20px'}), 
             $q->td({-class=>'mb_copyright'}, 'Copyright &copy;2015 Avant-Garde Marketing Solutions, Inc.. All rights reserved.  EXAMPLE ONLY - NOT INTENDED FOR PRODUCTION USE.'), 
             $q->td({-class=>'mb_right', -style=>'width: 20px'}));
			 
print $q->Tr($q->td({-class=>'mb_bottomleft', -style=>'width: 20px'}), 
             $q->td({-class=>'mb_bottom'}), 
             $q->td({-class=>'mb_bottomright', -style=>'width: 20px'}));

print $q->end_table;

print $q->end_form;
print $q->end_html;
